//+------------------------------------------------------------------+
//|                                                  PredictorEA.mq4 |
//|                                   Hakan SARI sistemliborsaci.com |
//|                                  https://www.sistemliborsaci.com |
//+------------------------------------------------------------------+
#property copyright "Hakan SARI sistemliborsaci.com"
#property link      "https://www.sistemliborsaci.com"
#property version   "1.00"
#property strict


input string str0 = "------------ GENEL ---------------";

input int magic = 0;
input double sabit_lot = 0.01;
input double risk = 1;
input double max_lot = 10;
input int sl = 100;
input int tp = 100;
input int trail = 50;
input int maks_emir = 500;
input int basla_saat = 0;
input int bitis_saat = 24;

input string str1 = "------------ STRATEJI ---------------";


enum enDisplay
{
   en_lin,  // Display lines
   en_his,  // Display colored bars
   en_all,  // Display colored lines and bars
   en_lid,  // Display lines with dots
   en_hid,  // Display colored bars with dots
   en_ald,  // Display colored lines and bars with dots
   en_dot   // Display dots
};

extern int       OmaLength          = 25;       // Oma Length
extern double    OmaSpeed           = 2.5;      // Oma Speed
extern bool      OmaAdaptive        = true;     // Use Oma Adaptive true or false
extern double    Sensitivity        = 0.5;      // Sensivity Factor
extern double    StepSize           = 50;       // Step Size period
extern int       Shift              = 0;        // OShify
extern bool      HighLow            = false;    // High/Low Mode Switch (more sensitive)
extern double    Filter             = 0;        // Filter to use for filtering (<=0 - no filtering)
extern double    FilterPeriod       = 0;        // Filter period to use ( when <= 0, same as oma period) 
extern enDisplay DisplayType        = en_lin;   // Display type
extern int       LinesWidth         = 3;        // Lines width (when lines are included in display)
extern int       BarsWidth          = 1;        // Bars width (when bars are included in display)
extern bool      alertsOn           = true;     // Turn alerts on?
extern bool      alertsOnCurrent    = true;     // Alerts on current (still opened) bar?
extern bool      alertsMessage      = true;     // Alerts should display alert message?
extern bool      alertsSound        = true;     // Alerts should play alert sound?
extern bool      alertsEmail        = false;    // Alerts should send alert email?
extern bool      alertsNotification = false;    // Alerts should send alert notification?
extern int       ArrowCodeUp        = 159;      // Up Arrow code
extern int       ArrowCodeDn        = 159;      // Down Arrow code
extern int       ArrowSizeUp        = 2;        // Up Arrow Size 
extern int       ArrowSizeDn        = 2;        // Down Arrow Size
extern double    ArrowGapUp         = 0.5;      // Gap for arrow up        
extern double    ArrowGapDn         = 0.5;      // Gap for arrow down
input int gecikme = 1;





input string str2 = "------------ HEDGE ---------------";

input bool hedge_aktif = true;
input int hedge_aralik = 100;
input double hedge_lot_kati = 1.1;
input double hedge_mesafe_kati = 1;
input bool hedge_kurtar = true;
input int hedge_kurtar_pips = 10;




//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+


double orta = 0, kirmizi1 = 0, kirmizi2=0, yesil1=0, yesil2=0;
int son_emir = 0;

void OnTick()
  {
//---




   int saat = Hour();

   if(saat>=basla_saat && saat<bitis_saat) {
      aktif = 1;
   } else {
      aktif = 0;
   }








   
   profitpips();
   

   double abuy2 = iCustom(Symbol(),Period(),"step one more average 2.3",OmaLength,OmaSpeed,OmaAdaptive,Sensitivity,StepSize,Shift,HighLow,Filter,FilterPeriod,DisplayType
   ,LinesWidth,BarsWidth,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotification,ArrowCodeUp,ArrowCodeDn,ArrowSizeUp,ArrowSizeDn,ArrowGapUp,ArrowGapDn,2,gecikme+1);
   
   double asell2 = iCustom(Symbol(),Period(),"step one more average 2.3",OmaLength,OmaSpeed,OmaAdaptive,Sensitivity,StepSize,Shift,HighLow,Filter,FilterPeriod,DisplayType
   ,LinesWidth,BarsWidth,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotification,ArrowCodeUp,ArrowCodeDn,ArrowSizeUp,ArrowSizeDn,ArrowGapUp,ArrowGapDn,3,gecikme+1);
   

   double abuy1 = iCustom(Symbol(),Period(),"step one more average 2.3",OmaLength,OmaSpeed,OmaAdaptive,Sensitivity,StepSize,Shift,HighLow,Filter,FilterPeriod,DisplayType
   ,LinesWidth,BarsWidth,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotification,ArrowCodeUp,ArrowCodeDn,ArrowSizeUp,ArrowSizeDn,ArrowGapUp,ArrowGapDn,2,gecikme);
   
   double asell1 = iCustom(Symbol(),Period(),"step one more average 2.3",OmaLength,OmaSpeed,OmaAdaptive,Sensitivity,StepSize,Shift,HighLow,Filter,FilterPeriod,DisplayType
   ,LinesWidth,BarsWidth,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotification,ArrowCodeUp,ArrowCodeDn,ArrowSizeUp,ArrowSizeDn,ArrowGapUp,ArrowGapDn,3,gecikme);
   


   if(abuy1 == 2147483647) abuy1 = 0;
   if(abuy2 == 2147483647) abuy2 = 0;

   if(asell1 == 2147483647) asell1 = 0;
   if(asell2 == 2147483647) asell2 = 0;

   // Print("abuy1 = ",abuy1," abuy2 = ",abuy2," asell1 = ",asell1," asell2 = ",asell2);

   if(kac_order == 0 ) {
      
      Lots = 0;
      
      if(aktif == 1) {

            if(asell2 != 0 && asell1 == 0) {
               GetLotSize();
               son_emir = OrderSend(Symbol(),OP_BUY,Lots,Ask,0,(sl>0 && hedge_aktif == false ? Ask-sl*Point : 0 ),(tp>0 && hedge_aktif == false ? Ask+tp*Point : 0 ),"1",magic,0,clrBlue);
            } else if(asell2 == 0 && asell1 != 0) {
               GetLotSize();
               son_emir = OrderSend(Symbol(),OP_SELL,Lots,Bid,0,(sl>0 && hedge_aktif == false ? Bid+sl*Point : 0 ),(tp>0 && hedge_aktif == false ? Bid-tp*Point : 0 ),"1",magic,0,clrRed);
            }
   
      }
   
   
   } else if(kac_order<maks_emir && hedge_aktif == true) {
      
      int rd = OrderSelect(son_emir,SELECT_BY_TICKET);
      int kacinci_emir = StrToInteger(OrderComment());
      
      if(Lots == 0 && kac_order == 1) {
         Lots = OrderLots();
      }
      
      
      if(OrderType()<2) {

         double dfiyat = 0;
         double dlot = (max_lot<NormalizeDouble(Lots*MathPow(hedge_lot_kati,kacinci_emir),2) ? max_lot :NormalizeDouble(Lots*MathPow(hedge_lot_kati,kacinci_emir),2) );
         
         // Print("#",OrderTicket()," dlot:",dLot," -> Lots:",Lots," kacinci_emir:",kacinci_emir," hedge_lot_kati:",hedge_lot_kati);
         
         if(OrderType() == 0) {
         
            dfiyat = NormalizeDouble(OrderOpenPrice()-hedge_aralik*MathPow(hedge_mesafe_kati,kacinci_emir)*Point,Digits);
            son_emir = OrderSend(Symbol(),(dfiyat<Ask ? OP_BUYLIMIT : OP_BUY ), dlot , (dfiyat<Ask ? dfiyat : Ask),0,0,0,IntegerToString(kacinci_emir+1),magic,0,clrBlue);

         } else if(OrderType() == 1) {
         
            dfiyat = NormalizeDouble(OrderOpenPrice()+hedge_aralik*MathPow(hedge_mesafe_kati,kacinci_emir)*Point,Digits);
            son_emir = OrderSend(Symbol(),(dfiyat>Bid ? OP_SELLLIMIT : OP_SELL) , dlot , (dfiyat>Bid ? dfiyat : Bid),0,0,0,IntegerToString(kacinci_emir+1),magic,0,clrRed);

         }
      
      
      }
   
   
   }



   
  }
//+------------------------------------------------------------------+



int kac_order = 0;
int son_trend = -1;
double toplam_kar = 0;

void profitpips()
{
  double profitpips = 0;
  
  kac_order = 0;
  son_emir = 0;
  son_trend = -1;
  toplam_kar = 0;
  
  double ilk_emir_fiyat = 0;
  double son_emir_fiyat = 0;
  int ilk_emir_id = 0;
  int son_emir_id = 0;
  double ilk_emir_lot = 0;
  double son_emir_lot = 0;
  
  double toplam_orta_fiyat = 0;
  double toplam_orta_lot = 0;
  double son_sl = 0;
  
  int acik_emir = 0;
  int bekleyen_emir = 0;
  
  
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
      int sonuc = OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic) continue;
           
      kac_order++;     
      
      
      toplam_kar = toplam_kar + ( OrderProfit()+OrderSwap()+OrderCommission() );
      
      if(son_emir == 0) {
         son_emir = OrderTicket();
         
      }
      
      if(son_trend == -1 && OrderType()<2) {
         son_trend = OrderType();
      } 
      
      if(OrderType()<2 && ilk_emir_fiyat==0) {
         ilk_emir_fiyat = OrderOpenPrice();
         ilk_emir_id = OrderTicket();
         ilk_emir_lot = OrderLots();
      }
      if(OrderType()<2) {
      
         if(OrderStopLoss()>0 && son_sl == 0) {
            son_sl = OrderStopLoss();
         } 
         
         acik_emir++;
         
         toplam_orta_fiyat = toplam_orta_fiyat +   ( OrderOpenPrice() * OrderLots());
         toplam_orta_lot = toplam_orta_lot + OrderLots();
         
      
         son_emir_fiyat = OrderOpenPrice();
         son_emir_id = OrderTicket();
         son_emir_lot = OrderLots();
      } else {
         bekleyen_emir++;
      }
      

  }
  
  
      if(toplam_orta_lot>0) toplam_orta_fiyat = NormalizeDouble(toplam_orta_fiyat / toplam_orta_lot,Digits);
  
      
      
      if(bekleyen_emir>0 && acik_emir == 0) {
         hepsinikapa(2);
         profitpips();
      }
      
      
      if(trail>0 && kac_order>0) {
      
         
         if(son_trend == OP_BUY) {
            if(son_sl == 0 && toplam_orta_fiyat>0 && toplam_orta_fiyat+trail*2*Point<Bid) {
               update_sl (toplam_orta_fiyat+trail*Point);
            } else if(son_sl>0 && son_sl+trail*2*Point<Bid) {
               update_sl (son_sl+trail*Point);
            }
         } else if(son_trend == OP_SELL) {
            if(son_sl == 0 && toplam_orta_fiyat>0 && toplam_orta_fiyat-trail*2*Point>Ask) {
               update_sl (toplam_orta_fiyat-trail*Point);
            } else if(son_sl>0 && son_sl-trail*2*Point>Ask) {
               update_sl (son_sl-trail*Point);
            }
         }
      
      }
      
      
   
  
  
      int ig = 0;
  
      if(kac_order>3 && hedge_kurtar == true && ilk_emir_id>0 && son_emir_id>0) {
      
            if(son_trend == OP_BUY && ( (ilk_emir_fiyat*ilk_emir_lot+son_emir_fiyat*son_emir_lot)/ (ilk_emir_lot+son_emir_lot))+hedge_kurtar_pips*Point<=Bid ) {
               ig = OrderClose(ilk_emir_id,ilk_emir_lot,Bid,0,clrBlue);
               ig = OrderClose(son_emir_id,son_emir_lot,Bid,0,clrBlue);
               hepsinikapa(2);
               profitpips();
            } else if(son_trend == OP_SELL && ( (ilk_emir_fiyat*ilk_emir_lot+son_emir_fiyat*son_emir_lot)/ (ilk_emir_lot+son_emir_lot))-hedge_kurtar_pips*Point>=Ask ) {
               ig = OrderClose(ilk_emir_id,ilk_emir_lot,Ask,0,clrRed);
               ig = OrderClose(son_emir_id,son_emir_lot,Ask,0,clrRed);
               hepsinikapa(2);
               profitpips();
            }
      
      }
  
  
}




double MARGIN,LOTSTEP,MINLOT,MAXLOT;

int aktif = 0;


double Lots,dLot;
datetime last_order2;


void GetLotSize(){
        double eq,ll,kol; double koli;
        
        MARGIN=MarketInfo(Symbol(),MODE_MARGINREQUIRED); if(MARGIN==0){MARGIN=1000; Print("MARGINREQUIRED error");}
        LOTSTEP=MarketInfo(Symbol(),MODE_LOTSTEP); if(LOTSTEP==0){LOTSTEP=0.1; Print("LOTSTEP error");}
        MINLOT=MarketInfo(Symbol(),MODE_MINLOT); if(MINLOT==0){MINLOT=0.1; Print("MINLOT error");}
        MAXLOT=MarketInfo(Symbol(),MODE_MAXLOT); if(MAXLOT==0){MAXLOT=1000; Print("MAXLOT error");}           
        
        if(sabit_lot>0) {
         Lots=sabit_lot;
         return;
        } else {
                eq=NormalizeDouble((NormalizeDouble(AccountEquity()/MARGIN,2) * risk)/100,2);
                ll=eq; koli=ll/LOTSTEP; kol=koli*LOTSTEP;
                dLot=kol;
                if(dLot<MINLOT) dLot=MINLOT;
                if(dLot>MAXLOT) dLot=MAXLOT;
                Lots=dLot;
        }
        if(Lots>max_lot) Lots=max_lot;

}


void hepsinikapa( int itype = -1) {

  for(int i=OrdersTotal()-1; i>=0; i--)
  {
      int sonuc = OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic) continue;
      
      if(OrderType()>1) {
          sonuc = OrderDelete(OrderTicket());
      } else {
      
        if(OrderType()==0 && (itype == -1 || itype == 0)) sonuc = OrderClose(OrderTicket(),OrderLots(),Bid,0,CLR_NONE);
        else if(OrderType()==1 && (itype == -1 || itype == 1))              sonuc = OrderClose(OrderTicket(),OrderLots(),Ask,0,CLR_NONE);
      }
  }  

}



void update_sl( double price ) {

   if(price == 0) return;

  for(int i=OrdersTotal()-1; i>=0; i--)
  {
      int sonuc = OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic || OrderType()>1) continue;

         if( DoubleToStr(OrderStopLoss(),Digits) != DoubleToStr(price,Digits)  ) {
         
            int gb = OrderModify(OrderTicket(),OrderOpenPrice(),price,OrderTakeProfit(),0,(OrderType() == OP_BUY ? clrBlue : clrRed));
            
        }
        
            
  }  
}
